if has('lua')
    " neocompleteのオムニ補完設定

    " 他の補完プラグインがneocompleteを
    " 無効にしないようにcompletefuncを上書きする
    let g:neocomplete#force_overwrite_completefunc = 1
    " 他の補完プラグインのオムニ補完を呼び出す入力パターンを設定する
    if !exists('g:neocomplete#force_omni_input_patterns')
        let g:neocomplete#force_omni_input_patterns = {}
    endif

    " clang_complete(https://github.com/Rip-Rip/clang_complete)と組み合わせ
    let g:neocomplete#force_omni_input_patterns.c =
                \ '[^.[:digit:] *\t]\%(\.\|->\)'
    let g:neocomplete#force_omni_input_patterns.cpp =
                \ '[^.[:digit:] *\t]\%(\.\|->\)\|\h\w*::'
    let g:neocomplete#force_omni_input_patterns.objc =
                \ '[^.[:digit:] *\t]\%(\.\|->\)'
    let g:neocomplete#force_omni_input_patterns.objcpp =
                \ '[^.[:digit:] *\t]\%(\.\|->\)\|\h\w*::'

    " jedi-vim(https://github.com/davidhalter/jedi-vim)と組み合わせ
    let g:neocomplete#force_omni_input_patterns.python = '[^. \t]\.\w*'

else
    " neocomplcacheのオムニ補完設定

    " 他の補完プラグインがneocomplcacheを
    " 無効にしないようにcompletefuncを上書きする
    let g:neocomplcache_force_overwrite_completefunc = 1
    " 他の補完プラグインのオムニ補完を呼び出す入力パターンを設定する
    if !exists('g:neocomplcache_force_omni_patterns')
        let g:neocomplcache_force_omni_patterns = {}
    endif

    " clang_complete(https://github.com/Rip-Rip/clang_complete)と組み合わせ
    let g:neocomplcache_force_omni_patterns.c =
                \ '[^.[:digit:] *\t]\%(\.\|->\)'
    let g:neocomplcache_force_omni_patterns.cpp =
                \ '[^.[:digit:] *\t]\%(\.\|->\)\|\h\w*::'
    let g:neocomplcache_force_omni_patterns.objc =
                \ '[^.[:digit:] *\t]\%(\.\|->\)'
    let g:neocomplcache_force_omni_patterns.objcpp =
                \ '[^.[:digit:] *\t]\%(\.\|->\)\|\h\w*::'

    " jedi-vim(https://github.com/davidhalter/jedi-vim)と組み合わせ
    let g:neocomplcache_force_omni_patterns.python = '[^. \t]\.\w*'
endif
